/****************************************************************************
*
*                         Techniques Class Library
*
*  ========================================================================
*
*   Copyright (C) 1991-2004 SciTech Software, Inc. All rights reserved.
*
*   This file may be distributed and/or modified under the terms of the
*   GNU General Public License version 2.0 as published by the Free
*   Software Foundation and appearing in the file LICENSE.GPL included
*   in the packaging of this file.
*
*   Licensees holding a valid Commercial License for this product from
*   SciTech Software, Inc. may use this file in accordance with the
*   Commercial License Agreement provided with the Software.
*
*   This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
*   THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
*   PURPOSE.
*
*   See http://www.scitechsoft.com/license/ for information about
*   the licensing options available and how to purchase a Commercial
*   License Agreement.
*
*   Contact license@scitechsoft.com if any conditions of this licensing
*   are not clear to you, or you have questions about licensing options.
*
*  ========================================================================
*
* Language:     C++ 3.0
* Environment:  any
*
* Description:  Header file for error handling module.
*
****************************************************************************/

#ifndef __TCL_ERROR_HPP
#define __TCL_ERROR_HPP

#ifndef __TCL_TECHLIB_HPP
#include "tcl/techlib.hpp"
#endif

#define STK_UNDERFLOW   -1
#define STK_OVERFLOW    -2

// Pointer to the currently installed error handler

extern void (*TCL_errorHandler)(int err);
void TCL_defaultErrorHandler(int err);

#endif  // __TCL_ERROR_HPP
